!USER_ENTERED_COMMAND acme multipost setup units_gain
!WRAP_IN_UNDO NO
!
!  Adams Car-Ride
!  Copyright (C) 2016 MSC Software Corporation
!  All Rights Reserved.
!
!*******************************************************************
!
! Set the units gain for various types of actuation for the
! MULTI_POST_TESTRIG.
!
! $units:t=string
! $units_gain:t=variable
!
!END_OF_PARAMETERS
!
!
variable set variable_name=$_self.actuation_type &
 string_value=(eval(.ACME.multipost.variables.flag_actuation_type))
!
!!! Check actuation type.
if condition=(eval($_self.actuation_type!="displacement" && $_self.actuation_type!="velocity" && $_self.actuation_type!="acceleration" ))
   acar toolkit warning &
    warning=(eval("\"$_self.$actuation_type\" is an invalid actuation option for arbitrary")), &
            "excitation of the MULTI_POST_TESTRIG."
   variable set variable_name=.ACME.multipost.variables.errorFlag &
    integer_value=1
   return
end
!
!!! Set a variable with the proper units gain.
if condition=(eval($_self.actuation_type=="displacement"))
   if condition=("$units"=="mm" || "$units"=="m" || "$units"=="inch" || "$units"=="foot")
      aride toolkit get units_gain displacement &
       units=$units &
       units_gain=$units_gain &
       error_variable=.ACME.multipost.variables.errorFlag
   else
      acar toolkit warning &
       warning=(eval("\"$units\" is an invalid units option for displacement-based")), &
               "excitation of the MULTI_POST_TESTRIG."
      variable set variable_name=.ACME.multipost.variables.errorFlag &
       integer_value=1
      return
   end
elseif condition=(eval($_self.actuation_type=="velocity"))
   if condition=("$units"=="mm/s" || "$units"=="m/s" || "$units"=="inch/s" || "$units"=="foot/s")
      aride toolkit get units_gain velocity &
       units=$units &
       units_gain=$units_gain &
       error_variable=.ACME.multipost.variables.errorFlag
   else
      acar toolkit warning &
       warning=(eval("\"$units\" is an invalid units option for velocity-based")), &
               "excitation of the MULTI_POST_TESTRIG."
      variable set variable_name=.ACME.multipost.variables.errorFlag &
       integer_value=1
      return
   end
elseif condition=(eval($_self.actuation_type=="acceleration"))
   if condition=("$units"=="mm/s^2" || "$units"=="m/s^2" || "$units"=="inch/s^2" || "$units"=="foot/s^2" || "$units"=="g's")
      aride toolkit get units_gain acceleration &
       units=$units &
       units_gain=$units_gain &
       error_variable=.ACME.multipost.variables.errorFlag
   else
      acar toolkit warning &
       warning=(eval("\"$units\" is an invalid units option for acceleration-based")), &
               "excitation of the MULTI_POST_TESTRIG."
      variable set variable_name=.ACME.multipost.variables.errorFlag &
       integer_value=1
      return
   end

end
!
variable delete variable_name=(eval(db_children($_self,"variable")))
