!USER_ENTERED_COMMAND acme multipost setup common
!WRAP_IN_UNDO NO
!
!  Adams Car-Ride
!  Copyright (C) 2016 MSC Software Corporation
!  All Rights Reserved.
!
!*******************************************************************
!
! $assembly:t=model
! $variant:t=string:d=""
! $clear_message_window:t=list(yes,no):d=yes
! $error_variable:t=variable:d=.ACAR.variables.errorFlag
!
!END_OF_PARAMETERS
!
!
variable set variable_name=$_self.actuation_type &
 string_value=(eval(.ACME.multipost.variables.flag_actuation_type))
 
variable set variable_name=$_self.input_type &
 string_value=(eval(.ACME.multipost.variables.flag_input_type)) 
!
!!! Check actuation type and input locations combinations.
!
!!! Clear out message window.
if condition=(eval("$clear_message_window"=="yes"))
   acar toolkit message &
    message=" " append=no display=no closeable=yes echo_to_logfile=no
end
!
acar toolkit message &
  message="Setting up the vehicle assembly for the MULTI_POST_TESTRIG..."
!
!!! Read property files.
acar toolkit read property_files &
 assembly=$assembly &
 verbose=yes &
 error_variable=.ACME.multipost.variables.errorFlag
 
!!! Deactivate sse wheel jprims used in A/Car.
aride toolkit set spindle_lock_rotation_activity_sse &
 assembly=$assembly active=off
 
!!! Activate static wheel motions and body and yaw stakes.
aride fourpost set statics_constraints_activity &
 assembly=$assembly active=on
!
!!! Move the tire reference markers into the actuator pads.
acme multipost setup tire_reference_markers assembly=$assembly
!
!!! Set the activity of the tire UDEs based upon the input locations
!!! for the actuators.
if condition=(eval(.ACME.multipost.variables.flag_input_locations)=="wheel spindles")
   aride toolkit set acar_tires_activity assembly=$assembly active=off
else
   aride toolkit set acar_tires_activity assembly=$assembly active=no_opinion
end
!
!!! Make sure that suspension driveline activity is off if there is no powertrain.
!!! This might not occur when the assembly is loaded. When the driveline
!!! activity is on without a powertrain, the suspension is connected to ground,
!!! which is bad for a four-post simulation.
!!!! First, see if a powertrain exists.
!
!!! Lock the steering wheel.
aride toolkit set steering_wheel_lock_rotation_activity &
 assembly=$assembly active=no_opinion
!
!!! Assign time derivatives of kinematic actuators.

!
variable delete variable_name=(eval(db_children($_self,"variable")))
!
