!USER_ENTERED_COMMAND acme multipost setup tire_reference_markers
!WRAP_IN_UNDO NO
!
!  Adams Car-Ride
!  Copyright (C) 2016 MSC Software Corporation
!  All Rights Reserved.
!
!*******************************************************************
!
! Perform setup operations for the MULTI_POST_TESTRIG for
! kinematical actuation beneath the tires.
!
! $assembly:t=model
!
!END_OF_PARAMETERS
!
!
!!! Get tires.
variable set variable_name=$_self.all_tire_udes object_value=(none)
acar toolkit get_acar_tires &
 assembly=$assembly all_tire_udes=$_self.all_tire_udes
!
!!! Bail out if there are no tires. If there are some tires, but not all four, 
!!! acme multipost get acar_tire object will signal an error.
if condition=(eval($_self.all_tire_udes==(none)))
   return
end 
!
variable create variable=$_self.ac_tire_lf object_value=(none)
variable create variable=$_self.ac_tire_rf object_value=(none)
variable create variable=$_self.ac_tire_lr object_value=(none)
variable create variable=$_self.ac_tire_rr object_value=(none)
variable create variable=$_self.ac_tire_lr2 object_value=(none)
variable create variable=$_self.ac_tire_rr2 object_value=(none)
!
!!! Set the values of the tires to their actual values.
acme multipost get acar_tire object assembly=$assembly side="L" front_rear="F" &
 ac_tire=$_self.ac_tire_lf 
acme multipost get acar_tire object assembly=$assembly side="R" front_rear="F" &
 ac_tire=$_self.ac_tire_rf
acme multipost get acar_tire object assembly=$assembly side="L" front_rear="R" &
 ac_tire=$_self.ac_tire_lr
acme multipost get acar_tire object assembly=$assembly side="R" front_rear="R" &
 ac_tire=$_self.ac_tire_rr   
acme multipost get acar_tire object assembly=$assembly side="L" front_rear="R2" &
 ac_tire=$_self.ac_tire_lr2
acme multipost get acar_tire object assembly=$assembly side="R" front_rear="R2" &
 ac_tire=$_self.ac_tire_rr2   
!!! Rename the tire reference markers and floating markers 
!!! to imbed them in the pad mounts.
for variable=$_self.tir object=(eval($_self.ac_tire_lf))
   if condition=(!db_exists((eval($assembly.testrig.col_mount_post_pad_vertical_front//"."//$_self.tir.object_value.ref_marker.object_value.name))))
      marker modify &
       marker_name=(eval($_self.tir.object_value.ref_marker.object_value)) &
       new_marker_name=(eval($assembly.testrig.col_mount_post_pad_vertical_front//"."//$_self.tir.object_value.ref_marker.object_value.name))
   end
   if condition=(!db_exists((eval($assembly.testrig.col_mount_post_pad_vertical_front//"."//$_self.tir.object_value.j_fmarker.object_value.name))))
      floating_marker modify &
       floating_marker_name=(eval($_self.tir.object_value.j_fmarker.object_value)) &
       new_floating_marker_name=(eval($assembly.testrig.col_mount_post_pad_vertical_front//"."//$_self.tir.object_value.j_fmarker.object_value.name))
   end
end
for variable=$_self.tir object=(eval($_self.ac_tire_rf))
   if condition=(!db_exists((eval($assembly.testrig.cor_mount_post_pad_vertical_front//"."//$_self.tir.object_value.ref_marker.object_value.name))))
      marker modify &
       marker_name=(eval($_self.tir.object_value.ref_marker.object_value)) &
       new_marker_name=(eval($assembly.testrig.cor_mount_post_pad_vertical_front//"."//$_self.tir.object_value.ref_marker.object_value.name))
   end
   if condition=(!db_exists((eval($assembly.testrig.cor_mount_post_pad_vertical_front//"."//$_self.tir.object_value.j_fmarker.object_value.name))))
      floating_marker modify &
       floating_marker_name=(eval($_self.tir.object_value.j_fmarker.object_value)) &
       new_floating_marker_name=(eval($assembly.testrig.cor_mount_post_pad_vertical_front//"."//$_self.tir.object_value.j_fmarker.object_value.name))
   end
end
for variable=$_self.tir object=(eval($_self.ac_tire_lr))
   if condition=(!db_exists((eval($assembly.testrig.col_mount_post_pad_vertical_rear//"."//$_self.tir.object_value.ref_marker.object_value.name))))
      marker modify &
       marker_name=(eval($_self.tir.object_value.ref_marker.object_value)) &
       new_marker_name=(eval($assembly.testrig.col_mount_post_pad_vertical_rear//"."//$_self.tir.object_value.ref_marker.object_value.name))
   end
   if condition=(!db_exists((eval($assembly.testrig.col_mount_post_pad_vertical_rear//"."//$_self.tir.object_value.j_fmarker.object_value.name))))
      floating_marker modify &
       floating_marker_name=(eval($_self.tir.object_value.j_fmarker.object_value)) &
       new_floating_marker_name=(eval($assembly.testrig.col_mount_post_pad_vertical_rear//"."//$_self.tir.object_value.j_fmarker.object_value.name))
   end
end
for variable=$_self.tir object=(eval($_self.ac_tire_rr))
   if condition=(!db_exists((eval($assembly.testrig.cor_mount_post_pad_vertical_rear//"."//$_self.tir.object_value.ref_marker.object_value.name))))
      marker modify &
       marker_name=(eval($_self.tir.object_value.ref_marker.object_value)) &
       new_marker_name=(eval($assembly.testrig.cor_mount_post_pad_vertical_rear//"."//$_self.tir.object_value.ref_marker.object_value.name))
   end
   if condition=(!db_exists((eval($assembly.testrig.cor_mount_post_pad_vertical_rear//"."//$_self.tir.object_value.j_fmarker.object_value.name))))
      floating_marker modify &
       floating_marker_name=(eval($_self.tir.object_value.j_fmarker.object_value)) &
       new_floating_marker_name=(eval($assembly.testrig.cor_mount_post_pad_vertical_rear//"."//$_self.tir.object_value.j_fmarker.object_value.name))
   end
end
for variable=$_self.tir object=(eval($_self.ac_tire_lr2))
   if condition=(!db_exists((eval($assembly.testrig.col_mount_post_pad_vertical_rear2//"."//$_self.tir.object_value.ref_marker.object_value.name))))
      marker modify &
       marker_name=(eval($_self.tir.object_value.ref_marker.object_value)) &
       new_marker_name=(eval($assembly.testrig.col_mount_post_pad_vertical_rear2//"."//$_self.tir.object_value.ref_marker.object_value.name))
   end
   if condition=(!db_exists((eval($assembly.testrig.col_mount_post_pad_vertical_rear2//"."//$_self.tir.object_value.j_fmarker.object_value.name))))
      floating_marker modify &
       floating_marker_name=(eval($_self.tir.object_value.j_fmarker.object_value)) &
       new_floating_marker_name=(eval($assembly.testrig.col_mount_post_pad_vertical_rear2//"."//$_self.tir.object_value.j_fmarker.object_value.name))
   end
end
for variable=$_self.tir object=(eval($_self.ac_tire_rr2))
   if condition=(!db_exists((eval($assembly.testrig.cor_mount_post_pad_vertical_rear2//"."//$_self.tir.object_value.ref_marker.object_value.name))))
      marker modify &
       marker_name=(eval($_self.tir.object_value.ref_marker.object_value)) &
       new_marker_name=(eval($assembly.testrig.cor_mount_post_pad_vertical_rear2//"."//$_self.tir.object_value.ref_marker.object_value.name))
   end
   if condition=(!db_exists((eval($assembly.testrig.cor_mount_post_pad_vertical_rear2//"."//$_self.tir.object_value.j_fmarker.object_value.name))))
      floating_marker modify &
       floating_marker_name=(eval($_self.tir.object_value.j_fmarker.object_value)) &
       new_floating_marker_name=(eval($assembly.testrig.cor_mount_post_pad_vertical_rear2//"."//$_self.tir.object_value.j_fmarker.object_value.name))
   end
end
!
!!! Reposition the reference markers to place them at the pad origins. This
!!! must be done each time a simulation is submitted in case the tire UDE was
!!! modified by the user.
for variable=$_self.tir object=(eval($_self.all_tire_udes))
   marker modify &
    marker_name=(eval($_self.tir.object_value.ref_marker.object_value)) &
    location=(loc_relative_to({0,0,0}, (eval($_self.tir.object_value.ref_marker.object_value.parent))))
end
!
!!! Adjust pad height for appearance and to give a good starting point for a
!!! static-equilibrium analysis.
      
!!! Variable to store minimum of all tire radii.
variable set variable_name=$_self.rmin real_value=0.0 units=length
!!! Get rmin.
aride toolkit get acar_tire radius minimum assembly=$assembly rmin=$_self.rmin
!!! Variable to store maximum height above ground of tire bottoms
!!! for all tires.
variable set variable_name=$_self.hmax real_value=0.0 units=length
!!! Get hmax.
aride toolkit get acar_tire height maximum assembly=$assembly hmax=$_self.hmax
   
!!! Shift the Z coordinate of the std_tire_ref up by hmax + 2% of rmin.
!!! The pad parts get their X and Y coordinates from std_tire_ref.
variable set variable=$_self.loc_glb_new &
 real_value=(eval(loc_global({0,0,0}, $assembly.testrig.ground.std_tire_ref)*{1,1,0} + ($_self.hmax + 0.02*$_self.rmin)*{0,0,1}))
!
marker modify marker_name=$assembly.testrig.ground.std_tire_ref &
 location=(eval($_self.loc_glb_new))
!
variable delete variable_name=(eval(db_children($_self,"variable")))
