!USER_ENTERED_COMMAND acme multipost analysis submit
!WRAP_IN_UNDO NO
!
!  Adams Car-Ride
!  Copyright (C) 2016 MSC Software Corporation
!  All Rights Reserved.
!
!*******************************************************************
!
! $assembly:t=model
! $variant:t=string:d=""
! $output_prefix:t=string
! $time_final:t=real:gt=0
! $analysis_mode:t=list(interactive,graphical,background,files_only):d=interactive
! $log_file:t=list(yes,no):d=yes
! $comment:t=string:d="":c=0
! $load_results:t=list(yes,no):d=yes
! $number_of_steps:t=integer:gt=0
! $error_variable:t=variable:d=.ACAR.variables.errorFlag
!
!END_OF_PARAMETERS
!
!
if condition=("$analysis_mode" != "background" && "$analysis_mode" != "files_only")
   acar toolkit message message="Simulation is beginning..."
end
!
!!! make sure the posters are active
!!! Activate the motions to prevent the pads from moving vertically
ude attributes instance_name=$assembly.testrig.jms_post_pad_vertical_lf &
 active=on dependents_active=on
ude attributes instance_name=$assembly.testrig.jms_post_pad_vertical_rf &
 active=on dependents_active=on
ude attributes instance_name=$assembly.testrig.jms_post_pad_vertical_lr &
 active=on dependents_active=on
ude attributes instance_name=$assembly.testrig.jms_post_pad_vertical_rr &
 active=on dependents_active=on
ude attributes instance_name=$assembly.testrig.jms_post_pad_vertical_lr2 &
 active=on dependents_active=on
ude attributes instance_name=$assembly.testrig.jms_post_pad_vertical_rr2 &
 active=on dependents_active=on
!
!!!! Perform the analysis.
acme analysis full_vehicle submit &
 assembly=$assembly &
 analysis_name="$'output_prefix'_multipost" &
 end_time=$time_final &
 number_of_steps=$number_of_steps &
 analysis_mode=$analysis_mode &
 load_results=$load_results &
 road_data_file="<acar_shared>/roads.tbl/2d_flat.rdf" &
 update_road_height=no &
 moving_road=yes &
 generate_road_geometry=no &
 simulation_type=multipost_time
!
if condition=($log_file)
   acar analysis full_vehicle log &
    assembly=$assembly &
    analysis_name="$'output_prefix'_multipost" &
    analysis_type="ACME_MULTI_POST_TESTRIG" &
    analysis_log_file="$'output_prefix'_multipost.log" &
    comment=$comment &
    end_time=$time_final &
    number_of_steps=$number_of_steps &
    road_data_file="<acar_shared>/roads.tbl/2d_flat.rdf" &
    initial_velocity=0.0 &
    velocity_units="m_sec" &
    input_parameters="general input" &
    parameter_values=("$number_of_steps")
end
!
if condition=("$analysis_mode"!="background" && "$analysis_mode"!="files_only")
   acar toolkit message message="Simulation is complete."
end
!
variable delete variable_name=(eval(db_children($_self,"variable")))
